// src/graphicalterminalio.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef GRAPHICALTERMINALIO_HH
#define GRAPHICALTERMINALIO_HH 1

#include "config.h"
#include "gettext.h"

#include <gtkmm/box.h>
#include <gtkmm/entry.h>
#include <gtkmm/textview.h>
#include <glibmm/ustring.h>

#include "iomanager.hh"

// ---------------------------------------------

class GraphicalTerminalIO;

// ---------------------------------------------

/** \brief 
 * 
 * ... long desc ... */
class GraphicalTerminalIO : public IOManager, public Gtk::VBox {
  typedef unsigned int size_type;
public:
  GraphicalTerminalIO();
  virtual ~GraphicalTerminalIO();
  
  virtual size_type  write_buffer(const Glib::ustring& buffer);
  virtual size_type  read_command(Glib::ustring& buffer) const;
private:
  Gtk::TextView   text_output;
  Gtk::Entry      text_input;
};

#endif
